// RSSMA_AM_ExampleDlg.h : header file
//

#if !defined(AFX_RSSMA_AM_EXAMPLEDLG_H__A7C80093_2DC2_4B08_AA6E_2C97214209C4__INCLUDED_)
#define AFX_RSSMA_AM_EXAMPLEDLG_H__A7C80093_2DC2_4B08_AA6E_2C97214209C4__INCLUDED_

#include "RSSMA_LFGen1.h"
#include "RSSMA_LFGen2.h"
#include "RSSMA_Noise.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* Error check macro for driver functions */

#define FT_CHECKERR(fcal, err) if ((rssma_status = fcal) < 0){\
								 rssma_close(instrSession);\
        						 sprintf (buffer, "Error: %ld, %s", rssma_status, err);\
        						 GetDlgItem(IDAPPLY)->EnableWindow (TRUE);\
        						 GetDlgItem(IDCANCEL)->EnableWindow (TRUE);\
								 AfxMessageBox (buffer, MB_OK);\
        						 return;\
        						 }

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_AM_ExampleDlg dialog

class CRSSMA_AM_ExampleDlg : public CDialog
{
// Construction
public:
	CRSSMA_AM_ExampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRSSMA_AM_ExampleDlg)
	enum { IDD = IDD_RSSMA_AM_EXAMPLE_DIALOG };
	CButton	m_AMState;
	CButton	m_Noise;
	CButton	m_LFGen2;
	CButton	m_LFGen1;
	CButton	m_Exit;
	CButton	m_Apply;
	BOOL	m_Query;
	BOOL	m_Reset;
	CString	m_ResName;
	double	m_RFFreq;
	double	m_RFLevel;
	BOOL	m_RFState;
	double	m_AMDepth;
	int		m_AMSource;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRSSMA_AM_ExampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON	m_hIcon;
	BOOL	bAMState;
	double	nBwid;
	BOOL	nBwidLim;
	int		nDistrib;
	double	lfgen1Depth, lfgen1Freq;
	double	fall, lfgen2Freq, high, low, rise;
	int		shape;
	CRSSMA_LFGen1 m_LFGen1Dlg;
	CRSSMA_LFGen2 m_LFGen2Dlg;
	CRSSMA_Noise  m_NoiseDlg;

	// Generated message map functions
	//{{AFX_MSG(CRSSMA_AM_ExampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnApply();
	afx_msg void OnLfgen1Button();
	afx_msg void OnLfgen2Button();
	afx_msg void OnNoiseButton();
	afx_msg void OnAmstate();
	afx_msg void OnSelchangeAmSource();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RSSMA_AM_EXAMPLEDLG_H__A7C80093_2DC2_4B08_AA6E_2C97214209C4__INCLUDED_)
