// RSSMA_LFGen2.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMA_FM_Example.h"
#include "RSSMA_LFGen2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_LFGen2 dialog


CRSSMA_LFGen2::CRSSMA_LFGen2(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMA_LFGen2::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMA_LFGen2)
	m_LFGen2Fall = 1.0e-6;
	m_LFGen2Freq = 1.0e3;
	m_LFGen2High = 1.0e-6;
	m_LFGen2Low = 1.0e-6;
	m_LFGen2Rise = 1.0e-6;
	m_LFGen2Shape = 0;
	//}}AFX_DATA_INIT
}


void CRSSMA_LFGen2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMA_LFGen2)
	DDX_Control(pDX, IDC_LFGEN2_LOW, m_LFGen2LowCtrl);
	DDX_Control(pDX, IDC_LFGEN2_FALL, m_LFGen2FallCtrl);
	DDX_Control(pDX, IDC_LFGEN2_HIGH, m_LFGen2HighCtrl);
	DDX_Control(pDX, IDC_LFGEN2_RISE, m_LFGen2RiseCtrl);
	DDX_Text(pDX, IDC_LFGEN2_FALL, m_LFGen2Fall);
	DDX_Text(pDX, IDC_LFGEN2_FREQ, m_LFGen2Freq);
	DDX_Text(pDX, IDC_LFGEN2_HIGH, m_LFGen2High);
	DDX_Text(pDX, IDC_LFGEN2_LOW, m_LFGen2Low);
	DDX_Text(pDX, IDC_LFGEN2_RISE, m_LFGen2Rise);
	DDX_CBIndex(pDX, IDC_LFGEN2_SHAPE, m_LFGen2Shape);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSMA_LFGen2, CDialog)
	//{{AFX_MSG_MAP(CRSSMA_LFGen2)
	ON_CBN_SELCHANGE(IDC_LFGEN2_SHAPE, OnSelchangeLfgen2Shape)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CRSSMA_LFGen2::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if(m_LFGen2Shape != 3)
	{
		m_LFGen2RiseCtrl.EnableWindow(FALSE);
		m_LFGen2HighCtrl.EnableWindow(FALSE);
		m_LFGen2FallCtrl.EnableWindow(FALSE);
		m_LFGen2LowCtrl.EnableWindow(FALSE);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_LFGen2 message handlers

void CRSSMA_LFGen2::getValues(double* fall, double* lfgen2Freq, double* high, double* low, double* rise, int* shape)
{
	*fall = m_LFGen2Fall;
	*lfgen2Freq = m_LFGen2Freq;
	*high = m_LFGen2High;
	*low = m_LFGen2Low;
	*rise = m_LFGen2Rise;
	*shape = m_LFGen2Shape;
}

void CRSSMA_LFGen2::OnSelchangeLfgen2Shape() 
{
	UpdateData(TRUE);

	m_LFGen2RiseCtrl.EnableWindow(FALSE);

	if(m_LFGen2Shape == 3)
	{
		m_LFGen2RiseCtrl.EnableWindow(TRUE);
		m_LFGen2HighCtrl.EnableWindow(TRUE);
		m_LFGen2FallCtrl.EnableWindow(TRUE);
		m_LFGen2LowCtrl.EnableWindow(TRUE);
	}
	else
	{
		m_LFGen2RiseCtrl.EnableWindow(FALSE);
		m_LFGen2HighCtrl.EnableWindow(FALSE);
		m_LFGen2FallCtrl.EnableWindow(FALSE);
		m_LFGen2LowCtrl.EnableWindow(FALSE);
	}
}
