// RSSMA_PM_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMA_PM_Example.h"
#include "RSSMA_PM_ExampleDlg.h"
#include "rssma.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_PM_ExampleDlg dialog

CRSSMA_PM_ExampleDlg::CRSSMA_PM_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMA_PM_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMA_PM_ExampleDlg)
	m_ResName = _T("GPIB::28");
	m_Query = TRUE;
	m_Reset = TRUE;
	m_PMMode = 0;
	m_PMIntDev = 1.0;
	m_PMSource = 0;
	m_RFFreq = 1.0e9;
	m_RFLevel = -30.0;
	m_RFState = FALSE;
	bPMState = FALSE;
	nBwid = 100.0e3;
	lfgen1Freq = 1.0e3;
	lfgen1Dev = 1.0;
	lfgen2Freq = 1.0e3;
	rise = 1.0e-6;
	fall = 1.0e-6;
	high = 1.0e-6;
	low = 1.0e-6;
	nDistrib = 0;
	shape = 0;
	nBwidLim = 0;	
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSSMA_PM_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMA_PM_ExampleDlg)
	DDX_Control(pDX, IDPMSTATE, m_PMState);
	DDX_Control(pDX, IDNOISE_BUTTON, m_Noise);
	DDX_Control(pDX, IDLFGEN2_BUTTON, m_LFGen2);
	DDX_Control(pDX, IDLFGEN1_BUTTON, m_LFGen1);
	DDX_Control(pDX, IDCANCEL, m_Exit);
	DDX_Control(pDX, IDAPPLY, m_Apply);
	DDX_Check(pDX, IDC_ID_QUERY, m_Query);
	DDX_Text(pDX, IDC_PM_INT_DEV, m_PMIntDev);
	DDX_CBIndex(pDX, IDC_PM_MODE, m_PMMode);
	DDX_CBIndex(pDX, IDC_PM_SOURCE, m_PMSource);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RESOURCE_DESCRIPTOR, m_ResName);
	DDX_Text(pDX, IDC_RF_FREQ, m_RFFreq);
	DDX_Text(pDX, IDC_RF_LEVEL, m_RFLevel);
	DDX_Check(pDX, IDC_RF_STATE, m_RFState);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSMA_PM_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRSSMA_PM_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDPMSTATE, OnPmstate)
	ON_CBN_SELCHANGE(IDC_PM_SOURCE, OnSelchangePmSource)
	ON_BN_CLICKED(IDLFGEN1_BUTTON, OnLfgen1Button)
	ON_BN_CLICKED(IDLFGEN2_BUTTON, OnLfgen2Button)
	ON_BN_CLICKED(IDNOISE_BUTTON, OnNoiseButton)
	ON_BN_CLICKED(IDAPPLY, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_PM_ExampleDlg message handlers

BOOL CRSSMA_PM_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_LFGen1.EnableWindow(FALSE);
	m_LFGen2.EnableWindow(FALSE);
	m_Noise.EnableWindow(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSSMA_PM_ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSSMA_PM_ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSSMA_PM_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSSMA_PM_ExampleDlg::OnPmstate() 
{
	CString label;

	bPMState = !bPMState;
	if (bPMState)
		label = "On";
	else
		label = "Off";

	m_PMState.SetWindowText(label);	
}

void CRSSMA_PM_ExampleDlg::OnSelchangePmSource() 
{
	UpdateData(TRUE);

	m_LFGen1.EnableWindow(FALSE);
	m_LFGen2.EnableWindow(FALSE);
	m_Noise.EnableWindow(FALSE);

	switch(m_PMSource)
	{
	case 1:	{	// LFGEN 1
			 m_LFGen1.EnableWindow(TRUE);
			} break;
	case 2:	{	// LFGEN 2
			 m_LFGen2.EnableWindow(TRUE);
			} break;	
	case 3:	{	// LFGEN 1 + 2
			 m_LFGen1.EnableWindow(TRUE);
			 m_LFGen2.EnableWindow(TRUE);
			} break;
	case 4:	{	// NOISE
			 m_Noise.EnableWindow(TRUE);
			} break;
	case 5:	{	// LFGEN1 + NOISE
			 m_LFGen1.EnableWindow(TRUE);
			 m_Noise.EnableWindow(TRUE);
			} break;
	case 6:	{	// LFGEN2 + NOISE
			 m_LFGen2.EnableWindow(TRUE);
			 m_Noise.EnableWindow(TRUE);
			} break;
	}			
}


void CRSSMA_PM_ExampleDlg::OnLfgen1Button() 
{
	UpdateData(TRUE);
	m_LFGen1Dlg.setDeviationEnabled((m_PMSource == 3) ? TRUE : FALSE);
	m_LFGen1Dlg.DoModal();
	UpdateData(FALSE);	
	m_LFGen1Dlg.getValues(&lfgen1Dev, &lfgen1Freq);		
}


void CRSSMA_PM_ExampleDlg::OnLfgen2Button() 
{
	UpdateData(TRUE);
	m_LFGen2Dlg.DoModal();
	UpdateData(FALSE);
	m_LFGen2Dlg.getValues(&fall, &lfgen2Freq, &high, &low, &rise, &shape);
}


void CRSSMA_PM_ExampleDlg::OnNoiseButton() 
{
	UpdateData(TRUE);
	m_NoiseDlg.DoModal();
	UpdateData(FALSE);	
	m_NoiseDlg.getValues(&nBwid, &nBwidLim, &nDistrib);	
}


void CRSSMA_PM_ExampleDlg::OnApply() 
{
	ViStatus	rssma_status;
	ViSession	instrSession;
	char		buffer[512];
	HCURSOR		cur;

	cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	GetDlgItem(IDAPPLY)->EnableWindow (FALSE);
	GetDlgItem(IDCANCEL)->EnableWindow (FALSE);
	
	UpdateData();

    /* Initialize the driver */
	rssma_status = rssma_init((char *) ((LPCTSTR) m_ResName), (int)(m_Query), (int)(m_Reset), &instrSession);
	if (rssma_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );

		GetDlgItem(IDAPPLY)->EnableWindow (TRUE);
		GetDlgItem(IDCANCEL)->EnableWindow (TRUE);
		return;
	}

	//For Syncronisation 
	//Enable Operation Complete for STB Register
	FT_CHECKERR (rssma_EventStatusEnable(instrSession,1), "rssma_EventStatusEnable");
	//Clear Status
	FT_CHECKERR (rssma_ClearStatus(instrSession),"rssma_ClearStatus");	

    /* Configure RF output part */
	FT_CHECKERR (rssma_confRFFreq (instrSession, m_RFFreq, 0.0, FALSE, 0.0), "rssma_confRFFreq");
    FT_CHECKERR (rssma_confRFLevel (instrSession, m_RFLevel, 0.0, 30.0, FALSE, 0.0,
                                        RSSMA_OUTPUT_AMODE_AUTO, RSSMA_POWER_LEVEL_RCL_EXCLUDE), 
										"rssma_confRFLevel");

	/* Configure common PM settings */
    FT_CHECKERR (rssma_confPM (instrSession, bPMState, RSSMA_FM_SOURCE_INTERNAL,
                                   m_PMMode, m_PMIntDev, m_PMIntDev, 0.5,
                                   RSSMA_EXTERNAL_COUPLING_AC,
                                   RSSMA_EXT_INPUT_IMPEDANCE_G50,
                                   RSSMA_FM_EXTERNAL_DIGITAL_FORMAT_BOFFSET),
								   "rssma_confPM");

	if(m_PMSource)
	{
	    /* This is internal FM example, so configure common internal parameters here */
        FT_CHECKERR (rssma_confPMInternal (instrSession, m_PMSource - 1, lfgen1Dev, lfgen1Freq,
                                        shape, lfgen2Freq), "rssma_confPMInternal");
			
        if ((m_PMSource == 1) || (m_PMSource == 3) || (m_PMSource == 5)) // LF Gen 1
        {
			FT_CHECKERR (rssma_confLFFreq (instrSession, TRUE, 1, lfgen1Freq, 1.0), 
						 "rssma_confLFFreq");
        }
        if ((m_PMSource == 2) || (m_PMSource == 3) || (m_PMSource == 6)) // LF Gen 2
        {
			FT_CHECKERR (rssma_confLFFreq (instrSession, TRUE, 2, lfgen2Freq, 1.0),
										   "rssma_confLFFreq");
            FT_CHECKERR (rssma_SetLFGenShape (instrSession, shape), "rssma_SetLFGenShape");
            if (shape == 3) // trapeze
            {
				FT_CHECKERR (rssma_SetLFGenShapeTrapeze (instrSession, RSSMA_LFOUTPUT_SHAPE_TRAPEZE_FALL,
                                                      fall), "rssma_SetLFGenShapeTrapeze");
                FT_CHECKERR (rssma_SetLFGenShapeTrapeze (instrSession, RSSMA_LFOUTPUT_SHAPE_TRAPEZE_RISE,
                                                      rise), "rssma_SetLFGenShapeTrapeze");
                FT_CHECKERR (rssma_SetLFGenShapeTrapeze (instrSession, RSSMA_LFOUTPUT_SHAPE_TRAPEZE_HIGH,
                                                      high), "rssma_SetLFGenShapeTrapeze");
                FT_CHECKERR (rssma_SetLFGenShapeTrapeze (instrSession, RSSMA_LFOUTPUT_SHAPE_TRAPEZE_LOW,
                                                      low), "rssma_SetLFGenShapeTrapeze");
            }
        }
        if ((m_PMSource == 4) || (m_PMSource == 5) || (m_PMSource == 6)) // Noise
        {
			FT_CHECKERR (rssma_confNoise (instrSession, nBwidLim, nBwid, nDistrib), 
						 "rssma_confNoise");
        }
	}

    /* Turn On/Off RF output at the end of sequence */
    FT_CHECKERR (rssma_SetOutputState(instrSession, m_RFState), "rssma_SetOutputState");

	rssma_close(instrSession);

	GetDlgItem(IDAPPLY)->EnableWindow (TRUE);
	GetDlgItem(IDCANCEL)->EnableWindow (TRUE);

	cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor ( cur );

    return;	
}
