// RSSMA_PM_ExampleDlg.h : header file
//

#if !defined(AFX_RSSMA_PM_EXAMPLEDLG_H__A1778738_3930_4CC1_99BD_D0BD3C912FF5__INCLUDED_)
#define AFX_RSSMA_PM_EXAMPLEDLG_H__A1778738_3930_4CC1_99BD_D0BD3C912FF5__INCLUDED_

#include "RSSMA_LFGen1.h"
#include "RSSMA_LFGen2.h"
#include "RSSMA_Noise.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* Error check macro for driver functions */

#define FT_CHECKERR(fcal, err) if ((rssma_status = fcal) < 0){\
								 rssma_close(instrSession);\
        						 sprintf (buffer, "Error: %ld, %s", rssma_status, err);\
        						 GetDlgItem(IDAPPLY)->EnableWindow (TRUE);\
        						 GetDlgItem(IDCANCEL)->EnableWindow (TRUE);\
								 AfxMessageBox (buffer, MB_OK);\
        						 return;\
        						 }

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_PM_ExampleDlg dialog

class CRSSMA_PM_ExampleDlg : public CDialog
{
// Construction
public:
	CRSSMA_PM_ExampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRSSMA_PM_ExampleDlg)
	enum { IDD = IDD_RSSMA_PM_EXAMPLE_DIALOG };
	CButton	m_PMState;
	CButton	m_Noise;
	CButton	m_LFGen2;
	CButton	m_LFGen1;
	CButton	m_Exit;
	CButton	m_Apply;
	BOOL	m_Query;
	double	m_PMIntDev;
	int		m_PMMode;
	int		m_PMSource;
	BOOL	m_Reset;
	CString	m_ResName;
	double	m_RFFreq;
	double	m_RFLevel;
	BOOL	m_RFState;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRSSMA_PM_ExampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON	m_hIcon;
	BOOL	bPMState;
	double	nBwid;
	BOOL	nBwidLim;
	int		nDistrib;
	double	lfgen1Dev, lfgen1Freq;
	double	fall, lfgen2Freq, high, low, rise;
	int		shape;
	CRSSMA_LFGen1 m_LFGen1Dlg;
	CRSSMA_LFGen2 m_LFGen2Dlg;
	CRSSMA_Noise  m_NoiseDlg;

	// Generated message map functions
	//{{AFX_MSG(CRSSMA_PM_ExampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnPmstate();
	afx_msg void OnSelchangePmSource();
	afx_msg void OnLfgen1Button();
	afx_msg void OnLfgen2Button();
	afx_msg void OnNoiseButton();
	afx_msg void OnApply();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RSSMA_PM_EXAMPLEDLG_H__A1778738_3930_4CC1_99BD_D0BD3C912FF5__INCLUDED_)
