// RSSMA_PULM_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMA_PULM_Example.h"
#include "RSSMA_PULM_ExampleDlg.h"
#include "rssma.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_PULM_ExampleDlg dialog

CRSSMA_PULM_ExampleDlg::CRSSMA_PULM_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMA_PULM_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMA_PULM_ExampleDlg)

	m_ResName = _T("GPIB::28");
	m_Query = TRUE;
	m_Reset = TRUE;
	m_PulmDelay = 1.0e-3;
	m_PulmPeriod = 1.0e-3;
	m_PulmWidth = 1.0e-3;
	m_DPulState = FALSE;
	m_RFFreq = 1.0e9;
	m_RFLevel = -30.0;
	m_RFState = FALSE;
	bPulmState = FALSE;
	bPulGenState = FALSE;
	dPulseWidth = 1.0e-3;
	dPulseDelay = 1.0e-3;
	trigMode = 0;
	trigSlope = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSSMA_PULM_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMA_PULM_ExampleDlg)
	DDX_Control(pDX, IDC_PULM_DELAY_TEXT, m_PulmDelayTxt);
	DDX_Control(pDX, IDC_PULM_DELAY, m_PulmDelayCtrl);
	DDX_Control(pDX, IDTRIGGER_BUTTON, m_Trigger);
	DDX_Control(pDX, IDPULM_STATE, m_PulmState);
	DDX_Control(pDX, IDPULGEN_STATE, m_PulGenState);
	DDX_Control(pDX, IDDPUL_BUTTON, m_DPulse);
	DDX_Control(pDX, IDCANCEL, m_Exit);
	DDX_Control(pDX, IDAPPLY, m_Apply);
	DDX_Check(pDX, IDC_DPUL_STATE, m_DPulState);
	DDX_Check(pDX, IDC_ID_QUERY, m_Query);
	DDX_Text(pDX, IDC_PULM_DELAY, m_PulmDelay);
	DDX_Text(pDX, IDC_PULM_PERIOD, m_PulmPeriod);
	DDX_Text(pDX, IDC_PULM_WIDTH, m_PulmWidth);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RESOURCE_DESCRIPTOR, m_ResName);
	DDX_Text(pDX, IDC_RF_FREQ, m_RFFreq);
	DDX_Text(pDX, IDC_RF_LEVEL, m_RFLevel);
	DDX_Check(pDX, IDC_RF_STATE, m_RFState);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSMA_PULM_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRSSMA_PULM_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDPULM_STATE, OnPulmState)
	ON_BN_CLICKED(IDPULGEN_STATE, OnPulGenState)
	ON_BN_CLICKED(IDC_DPUL_STATE, OnDpulState)
	ON_BN_CLICKED(IDDPUL_BUTTON, OnDPulseButton)
	ON_BN_CLICKED(IDTRIGGER_BUTTON, OnTrigModeButton)
	ON_BN_CLICKED(IDAPPLY, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_PULM_ExampleDlg message handlers

BOOL CRSSMA_PULM_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_DPulse.EnableWindow(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSSMA_PULM_ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSSMA_PULM_ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSSMA_PULM_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSSMA_PULM_ExampleDlg::OnPulmState() 
{
	CString label;

	bPulmState = !bPulmState;
	if (bPulmState)
		label = "On";
	else
		label = "Off";

	m_PulmState.SetWindowText(label);
}

void CRSSMA_PULM_ExampleDlg::OnPulGenState() 
{
	CString label;

	bPulGenState = !bPulGenState;
	if (bPulGenState)
		label = "On";
	else
		label = "Off";

	m_PulGenState.SetWindowText(label);	
}

void CRSSMA_PULM_ExampleDlg::OnDpulState() 
{	
	UpdateData();

	m_PulmDelayCtrl.EnableWindow(!m_DPulState);
	m_PulmDelayTxt.EnableWindow(!m_DPulState);
	m_DPulse.EnableWindow(m_DPulState);
}

void CRSSMA_PULM_ExampleDlg::OnDPulseButton() 
{
	UpdateData(TRUE);
	m_DPulseDlg.DoModal();
	UpdateData(FALSE);	
	m_DPulseDlg.getValues(&dPulseWidth, &dPulseDelay);			
}

void CRSSMA_PULM_ExampleDlg::OnTrigModeButton() 
{
	UpdateData(TRUE);
	m_TrigModeDlg.DoModal();
	UpdateData(FALSE);
	m_TrigModeDlg.getValues(&trigMode, &trigSlope);
}

void CRSSMA_PULM_ExampleDlg::OnApply() 
{
	ViStatus	rssma_status;
	ViSession	instrSession;
	char		buffer[512];
	HCURSOR		cur;

	cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	GetDlgItem(IDAPPLY)->EnableWindow (FALSE);
	GetDlgItem(IDCANCEL)->EnableWindow (FALSE);
	
	UpdateData();

    /* Initialize the driver */
	rssma_status = rssma_init((char *) ((LPCTSTR) m_ResName), (int)(m_Query), (int)(m_Reset), &instrSession);
	if (rssma_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );

		GetDlgItem(IDAPPLY)->EnableWindow (TRUE);
		GetDlgItem(IDCANCEL)->EnableWindow (TRUE);
		return;
	}

	//For Syncronisation 
	//Enable Operation Complete for STB Register
	FT_CHECKERR (rssma_EventStatusEnable(instrSession,1), "rssma_EventStatusEnable");
	//Clear Status
	FT_CHECKERR (rssma_ClearStatus(instrSession),"rssma_ClearStatus");	

    /* Configure RF output part */
	FT_CHECKERR (rssma_confRFFreq (instrSession, m_RFFreq, 0.0, FALSE, 0.0), "rssma_confRFFreq");
    FT_CHECKERR (rssma_confRFLevel (instrSession, m_RFLevel, 0.0, 30.0, FALSE, 0.0,
                                        RSSMA_OUTPUT_AMODE_AUTO, RSSMA_POWER_LEVEL_RCL_EXCLUDE), 
										"rssma_confRFLevel");

	/* Configure common PULM settings */
    FT_CHECKERR (rssma_confPulm (instrSession, bPulmState, RSSMA_PULM_SOURCE_INTERNAL,
                                   RSSMA_PULM_POLARITY_NORMAL, bPulGenState, 
								   m_PulmPeriod, m_PulmWidth, m_PulmDelay, 
								   m_DPulState, dPulseWidth, dPulseDelay, trigMode),
								   "rssma_confPulm");

	switch(trigMode)
	{
		case 1:	/* Ext Triggered */
		case 2:	/* Ext Gated */				  
			{
				FT_CHECKERR (rssma_SetInstrumentTriggerInputSlope (instrSession, trigSlope),
							 "rssma_SetInstrumentTriggerInputSlope");
			} break;
		default:
		case 0: 
			break;
	}		

    /* Turn On/Off RF output at the end of sequence */
    FT_CHECKERR (rssma_SetOutputState(instrSession, m_RFState), "rssma_SetOutputState");

	rssma_close(instrSession);

	GetDlgItem(IDAPPLY)->EnableWindow (TRUE);
	GetDlgItem(IDCANCEL)->EnableWindow (TRUE);

	cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor ( cur );

    return;	
}
