// RSSMA_PULM_ExampleDlg.h : header file
//

#if !defined(AFX_RSSMA_PULM_EXAMPLEDLG_H__E9DB93BF_AF90_4C8A_8D96_07EC5C898BC7__INCLUDED_)
#define AFX_RSSMA_PULM_EXAMPLEDLG_H__E9DB93BF_AF90_4C8A_8D96_07EC5C898BC7__INCLUDED_

#include "RSSMA_Double_Pulse.h"
#include "RSSMA_Trigger_Mode.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* Error check macro for driver functions */

#define FT_CHECKERR(fcal, err) if ((rssma_status = fcal) < 0){\
								 rssma_close(instrSession);\
        						 sprintf (buffer, "Error: %ld, %s", rssma_status, err);\
        						 GetDlgItem(IDAPPLY)->EnableWindow (TRUE);\
        						 GetDlgItem(IDCANCEL)->EnableWindow (TRUE);\
								 AfxMessageBox (buffer, MB_OK);\
        						 return;\
        						 }

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_PULM_ExampleDlg dialog

class CRSSMA_PULM_ExampleDlg : public CDialog
{
// Construction
public:
	CRSSMA_PULM_ExampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRSSMA_PULM_ExampleDlg)
	enum { IDD = IDD_RSSMA_PULM_EXAMPLE_DIALOG };
	CStatic	m_PulmDelayTxt;
	CEdit	m_PulmDelayCtrl;
	CButton	m_Trigger;
	CButton	m_PulmState;
	CButton	m_PulGenState;
	CButton	m_DPulse;
	CButton	m_Exit;
	CButton	m_Apply;
	BOOL	m_DPulState;
	BOOL	m_Query;
	double	m_PulmDelay;
	double	m_PulmPeriod;
	double	m_PulmWidth;
	BOOL	m_Reset;
	CString	m_ResName;
	double	m_RFFreq;
	double	m_RFLevel;
	BOOL	m_RFState;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRSSMA_PULM_ExampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON	m_hIcon;
	BOOL	bPulmState;
	BOOL	bPulGenState;
	double	dPulseWidth, dPulseDelay;
	int		trigMode, trigSlope;
	CRSSMA_Double_Pulse m_DPulseDlg;
	CRSSMA_Trigger_Mode m_TrigModeDlg;

	// Generated message map functions
	//{{AFX_MSG(CRSSMA_PULM_ExampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnPulmState();
	afx_msg void OnPulGenState();
	afx_msg void OnDpulState();
	afx_msg void OnDPulseButton();
	afx_msg void OnTrigModeButton();
	afx_msg void OnApply();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RSSMA_PULM_EXAMPLEDLG_H__E9DB93BF_AF90_4C8A_8D96_07EC5C898BC7__INCLUDED_)
