// RSSMA_Trigger_Mode.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMA_PULM_Example.h"
#include "RSSMA_Trigger_Mode.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_Trigger_Mode dialog


CRSSMA_Trigger_Mode::CRSSMA_Trigger_Mode(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMA_Trigger_Mode::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMA_Trigger_Mode)
	m_TriggerMode = 0;
	m_TriggerPolarity = 0;
	m_TriggerSlope = 0;
	//}}AFX_DATA_INIT
}


void CRSSMA_Trigger_Mode::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMA_Trigger_Mode)
	DDX_Control(pDX, IDC_TRIG_SLOPE_TEXT, m_TriggerSlopeTxt);
	DDX_Control(pDX, IDC_TRIG_POLARITY, m_TriggerPolarityCtrl);
	DDX_Control(pDX, IDC_TRIG_SLOPE, m_TriggerSlopeCtrl);
	DDX_Control(pDX, IDC_TRIG_POLARITY_TEXT, m_TriggerPolarityTxt);
	DDX_CBIndex(pDX, IDC_TRIG_MODE, m_TriggerMode);
	DDX_CBIndex(pDX, IDC_TRIG_POLARITY, m_TriggerPolarity);
	DDX_CBIndex(pDX, IDC_TRIG_SLOPE, m_TriggerSlope);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRSSMA_Trigger_Mode, CDialog)
	//{{AFX_MSG_MAP(CRSSMA_Trigger_Mode)
	ON_CBN_SELCHANGE(IDC_TRIG_MODE, OnSelchangeTrigMode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CRSSMA_Trigger_Mode::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	OnSelchangeTrigMode();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_Trigger_Mode message handlers

void CRSSMA_Trigger_Mode::getValues(int* trigMode, int* slope)
{
	*trigMode = m_TriggerMode;
	switch(m_TriggerMode)
	{
	case 1:
		{
		    *slope = m_TriggerSlope;
		} break;
	case 2:
		{
			*slope = m_TriggerPolarity;
		} break;
	}
}

void CRSSMA_Trigger_Mode::OnSelchangeTrigMode() 
{
	UpdateData(TRUE);

	switch(m_TriggerMode)
	{
		case 1:	
			{	// Ext Triggered
				m_TriggerSlopeCtrl.EnableWindow(TRUE);
				m_TriggerSlopeTxt.EnableWindow(TRUE);
				m_TriggerPolarityCtrl.EnableWindow(FALSE);
				m_TriggerPolarityTxt.EnableWindow(FALSE);
			} break;
		case 2: 
			{	// Ext Gated
				m_TriggerSlopeCtrl.EnableWindow(FALSE);
				m_TriggerSlopeTxt.EnableWindow(FALSE);
				m_TriggerPolarityCtrl.EnableWindow(TRUE);
				m_TriggerPolarityTxt.EnableWindow(TRUE);
			} break;
		default:
		case 0:	
			{	// Auto
				m_TriggerSlopeCtrl.EnableWindow(FALSE);
				m_TriggerSlopeTxt.EnableWindow(FALSE);
				m_TriggerPolarityCtrl.EnableWindow(FALSE);		
				m_TriggerPolarityTxt.EnableWindow(FALSE);
			} break;
	}
}
